package com.jenny.magic.entities;

import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraft.world.phys.EntityHitResult;
import net.minecraft.world.phys.Vec3;
import org.jetbrains.annotations.NotNull;

public class HurtfulProjectile extends BaseWandProjectile {
    public HurtfulProjectile(EntityType<? extends BaseWandProjectile> pEntityType, Level pLevel) {
        super(pEntityType, pLevel);
    }

    public HurtfulProjectile(Level pLevel) {
        super(entities.PROJECTILE_HURTFUL.get(), pLevel);
    }

    public String name() {
        return "hurtful_projectile";
    }

    @Override
    protected void hitEntity(@NotNull EntityHitResult pResult) {
        if (pResult.getEntity() instanceof LivingEntity) {
            Entity owner = this.getOwner();
            DamageSource damagesource;
            if (owner == null) {
                damagesource = this.damageSources().arrow(this, this);
            } else {
                damagesource = this.damageSources().arrow(this, owner);
                if (owner instanceof LivingEntity) {
                    ((LivingEntity) owner).setLastHurtMob(pResult.getEntity());
                }
            }
            pResult.getEntity().hurt(this.damageSources().arrow(this, this.getOwner()), 5);
            this.doPostHurtEffects((LivingEntity) pResult.getEntity());
        }
    }

    @Override
    public void hitParticles() {
        for (int i = 0; i < 20; i++) {
            Vec3 particlePos = particlePos(2);
            level().addParticle(ParticleTypes.LAVA, particlePos.x, particlePos.y, particlePos.z, 0, 0, 0);
        }
    }

    @Override
    protected ItemStack getPickupItem() {
        return ItemStack.EMPTY;
    }
}
