package com.jenny.magic.entities;

import com.jenny.magic.entities.client.BaseProjectileRenderer;
import net.minecraft.client.renderer.entity.EntityRenderers;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.MobCategory;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.RegistryObject;

import static com.jenny.magic.Magic.MODID;

public class entities {
    public static final DeferredRegister<EntityType<?>> ENTITY_TYPES =
            DeferredRegister.create(ForgeRegistries.ENTITY_TYPES, MODID);

    public static final RegistryObject<EntityType<HurtfulProjectile>> PROJECTILE_HURTFUL =
            ENTITY_TYPES.register("projectile_hurtful", () -> EntityType.Builder.<HurtfulProjectile>of(HurtfulProjectile::new, MobCategory.MISC)
                    .sized(0.3F, 0.3F).fireImmune().clientTrackingRange(8).build("projectile_hurtful"));

    public static void register(IEventBus eventBus) {
        ENTITY_TYPES.register(eventBus);
    }

    public static void registerRenderers() {
        EntityRenderers.register(PROJECTILE_HURTFUL.get(), BaseProjectileRenderer::new);
    }
}
